<template>
    <div class="container-fluid" v-if="muro">
        <div class="row">
            <div class="col"></div>
            <div class="col-8">
                    <div class="row row-cols-1">
                        <div class="col" v-if="usuario" >
                            <InfoPersonalVue :muro="muro" :publicaciones="publicaciones" :user="usuario"/>
                        </div>
                        <div class="col" v-if="muro">
                            <CarruselHistorias :muro="muro"/>
                        </div>
                        <div class="col bg-body-secondary">
                            <div class="row row-cols-1 g-4 mx-1 pt-2">
                                <div class="col d-flex justify-content-start">
                                    <router-link :to="'/publicaciones'" class="btn btn-primary">nueva publicacion</router-link>
                                </div>
                                <div v-if="publicaciones&&usuario" class="xd">
                                    <ComentReactComponentVue :posts="publicaciones"></ComentReactComponentVue>
                                </div>
                            </div>
                        </div>
                        <div class="col d-flex justify-content-center py-3 bg-body-secondary">
                            
                        </div>
                    </div>
            </div>
            <div class="col-3 py-2">
                <div class="row">
                    <div class="col-12" v-if="publicacionesFotos">
                        <CuadroFotos :publicaciones="publicacionesFotos" />
                    </div>
                </div>
                <div class="col-12">
                    <div class="row sugerencias">
                        <div class="col-12 my-4">
                            <h4 class="text-center text-white">Sugerencias</h4>
                        </div>
                        <div class="col-12 px-2">
                            <CarruselSugerancias></CarruselSugerancias>
                        </div>
                    </div>
                </div>
                <div class="col-12 mt-3" v-if="publicacionesDestacadas">
                    <CuadroPublicacionesDestacadas :publicaciones="publicacionesDestacadas"/>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import InfoPersonalVue from '@/components/muro/InfoPersonal.vue'
import CarruselSugerancias from '../../components/muro/CarruselSugerancias.vue'
import CarruselHistorias from "@/components/muro/CarruselHistoriaMuro.vue";
import CuadroFotos from "@/components/muro/CuadroFotos.vue"
import CuadroPublicacionesDestacadas from '@/components/muro/CuadroPublicacionesDestacadas.vue';
import axios from 'axios';
import ComentReactComponentVue from '@/components/coment_react/ComentReactComponent.vue';

export default {
    name: "MuroUsuario",
    components:{
        CarruselSugerancias,
        InfoPersonalVue,
        CarruselHistorias,
        CuadroFotos,
        CuadroPublicacionesDestacadas,
        ComentReactComponentVue
    },
    data(){
        return{
            id:null,
            muro:null,
            s:null,
            publicaciones:null,
            publicacionesFotos:null,
            publicacionesDestacadas:null,
            historias:null,
            usuario:null,
            publisYRecuerdos:null
        }
    },
    methods:{
        buscarFotos(array){
            const publicacionesFoto = array.filter(publicacion => publicacion.foto&&publicacion.imagenes.lenght!=0);
            this.publicacionesFotos= publicacionesFoto;
        },
        buscarDestacadas(array){
            const publicacionesDestacadas = array.filter(publicacion => publicacion.destacado&&publicacion.imagenes.lenght!=0);
            this.publicacionesDestacadas= publicacionesDestacadas;
        },
        async buscarMuro(){
            let muro=null;
            try{
                const response= await axios.get(`http://localhost:3001/muro/ver/${this.id}`);
                muro=response.data;
            }catch(e){
                console.log(e);
            }
            this.muro=muro;
            
        },
        async buscarPublicaciones(){
            try{
                let user=await axios.get(`http://localhost:3001/usuarios/sesion`)
                user=user.data;
                this.usuario=user;
                const response=await axios.get(`http://localhost:3001/p/publicaciones/muro?id_muro=${this.id}`)
                let publis= response.data;
                publis=publis.slice().reverse();
                this.buscarFotos(publis);
                this.buscarDestacadas(publis);
                this.publicaciones=publis;
            }catch(e){
                console.log(e)
            }
            
        },
        async llamarRecuerdos(){
            try {
                let res= await axios.get(`http://localhost:3001/recuerdos/usuario/${this.id}`);
                res=res.data;

                return res;
            } catch (error) {
                console.log(error)
            }
        },
        matchear(publicaciones, recuerdos){
            const array=publicaciones;
            for (let i=0; i<recuerdos.length;i++) {
                const recuerdo=recuerdos[i];
                for(let y=0; y<array.length;y++){
                    const publicacion= array[y];
                    if(publicacion.id==recuerdo.publicacion.id){
                        array[y]=recuerdo
                    }
                }
            }
            return array;
        }
    },
    async mounted(){
        this.id = this.$route.params.id;
        //axios.get(`http://localhost:3001/muro/ver/${this.id}`);
        this.buscarMuro();
        await this.buscarPublicaciones();
        const recuerdos= await this.llamarRecuerdos();
        console.log(recuerdos)
        const publis= [this.publicaciones];
        this.publisYRecuerdos= this.matchear(publis, recuerdos)
        console.log(this.publisYRecuerdos)
        
        
    },
}
</script>

<style scoped>





</style>